#include "test.h"

#if HAVE_LIBC_H
#  include <libc.h>
#endif

#undef index	// needed for NeXT

class QuitItem : public NCursesMenuItem
{
public:
  QuitItem() : NCursesMenuItem("Quit") {
  }

  bool action() {
    return TRUE;
  }
};
//
// -------------------------------------------------------------------------
//
class PassiveItem : public NCursesMenuItem {
public:
  PassiveItem(const char* text) : NCursesMenuItem(text) {
    options_off(O_SELECTABLE);
  }
};
//
// -------------------------------------------------------------------------
//
class MyMenu : public NCursesMenu
{
private:
  NCursesMenuItem** I;
  #define n_items 7

public:
  MyMenu ()
    : NCursesMenu (n_items+2, 7, (lines()-10)/2, (cols()-10)/2)
  {
    boldframe();
    set_mark (NULL);

    I = new NCursesMenuItem*[1+n_items];
    I[0] = new NCursesMenuItem("One");
    I[1] = new NCursesMenuItem("Two");
    I[2] = new NCursesMenuItem("Three");
    I[3] = new PassiveItem("-----");
    I[4] = new NCursesMenuItem("Pad");
    I[5] = new NCursesMenuItem("Six");
    I[6] = new QuitItem();
    I[7] = new NCursesMenuItem(); // Terminating empty item

    InitMenu(I,TRUE,TRUE);

    bkgd (COLOR_PAIR (9) | A_BOLD);
    set_foreground (COLOR_PAIR (0) | A_BOLD);
    set_background (COLOR_PAIR (2));
    set_grey (COLOR_PAIR (12));
  }

  ~MyMenu()
  {
  }
};
//
// -------------------------------------------------------------------------
//
// Titre de la fentre
void CComtrans::title ()
{
}

// Initialisation des couleurs personnalises  l'application
void CComtrans::init_color ()
{
  if (Root_Window->colors() > 1)
    {
      // Background des menus Noir sur Fond Cyan
      Root_Window->setcolor (2);
      Root_Window->setpalette (COLOR_BLACK, COLOR_CYAN);

      // Fond des fentres
      Root_Window->setcolor (5);
      Root_Window->setpalette (COLOR_BLACK, COLOR_WHITE);

      // Titre des fentres BLANC sur Fond BLEU
      Root_Window->setcolor (6);
      Root_Window->setpalette (COLOR_WHITE, COLOR_BLUE);

      // Message Important
      Root_Window->setcolor (7);
      Root_Window->setpalette (COLOR_BLACK, COLOR_RED);

      // Caractre en surbrillance
      Root_Window->setcolor (8);
      Root_Window->setpalette (COLOR_RED, COLOR_BLACK);

      // Blanc sur fond Cyan
      Root_Window->setcolor (9);
      Root_Window->setpalette (COLOR_WHITE, COLOR_CYAN);

      // Jaune sur fond Cyan
      Root_Window->setcolor (10);
      Root_Window->setpalette (COLOR_YELLOW, COLOR_CYAN);

      // Bleu sur fond Cyan
      Root_Window->setcolor (11);
      Root_Window->setpalette (COLOR_BLUE, COLOR_CYAN);

      // Noir sur fond Cyan
      Root_Window->setcolor (12);
      Root_Window->setpalette (COLOR_BLACK, COLOR_CYAN);

      // Rouge sur fond Cyan
      Root_Window->setcolor (13);
      Root_Window->setpalette (COLOR_RED, COLOR_CYAN);

      // Blanc sur fond Blanc
      Root_Window->setcolor (14);
      Root_Window->setpalette (COLOR_WHITE, COLOR_WHITE);

      // Jaune sur fond Rouge
      Root_Window->setcolor (15);
      Root_Window->setpalette (COLOR_YELLOW, COLOR_RED);
    }
}

// Excutable implicite de l'application
int CComtrans::run() 
{
  setlocale (LC_ALL, "fr_FR");

  init_color ();

  MyMenu menu;
  menu ();

  Root_Window->bkgd (COLOR_PAIR (0));
  Root_Window->erase ();

  refresh ();

  return (0);
}

//
// -------------------------------------------------------------------------
//

static CComtrans comtrans;

